#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const double EPS = 1e-5;
int n, k;
vector<int> c;

int get_cost(string s){
    int res = 0;
    for(char c: s){
        res = 2 * res + (c - '0');
    }
    return c[res];
}

int readAndCheckAnswer(InStream &in){
    string s = in.readToken("[01]{" + to_string(n) + "}", "ans");
    int res = 0;
    for(int i = 0; i + k <= n; ++i){
        res += get_cost(s.substr(i, k));
    }
    return res;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int t = 1;//inf.readInt();
    for(int _ = 0; _ < t; ++_){
        //setTestCase(_ + 1);
        n = inf.readInt();
        k = inf.readInt();
        c = inf.readInts(1 << k);
        int ja = readAndCheckAnswer(ans);
        int pa = readAndCheckAnswer(ouf);
        if (ja < pa) quitf(_wa, "jury has better cost than participant does (%d < %d)", ja, pa);
        if (ja > pa) quitf(_fail, "jury has worse cost than participant does (%d > %d)", ja, pa);
    }
    quitf(_ok, "ok %d test cases", t);
}
