import random
import math

def to_bin(x, k):
    s = ""
    while x > 0:
        s += str(x % 2)
        x //= 2
    while len(s) < k:
        s += '0'
    return s

def solve(tc):
    n, k = map(int, input().split())
    c = [int(x) for x in input().split()]
    if n < k:
        print('0' * n)
        return
    prev = [[0, 0] for _ in range(1 << k)]
    for i in range(1 << k):
        nxt = i >> 1
        prev[i][0] = nxt
        prev[i][1] = (1 << (k - 1)) + nxt
    dp = [[math.inf] * (1 << k) for _ in range(n - k + 1)]
    dp[0] = c
    for i in range(1, n - k + 1):
        for j in range(1 << k):
            dp[i][j] = min(dp[i - 1][prev[j][0]], dp[i - 1][prev[j][1]]) + c[j]
    i = n - k
    j = dp[-1].index(min(dp[-1]))
    ans = to_bin(j, k)
    while i > 0:
        if dp[i - 1][prev[j][0]] < dp[i - 1][prev[j][1]]:
            ans += '0'
            j = prev[j][0]
        else:
            ans += '1'
            j = prev[j][1]
        i -= 1
    ans = ans[::-1]
    print(ans)

multi = False

t = 1
if multi:
    t = int(input())
for i in range(1, t + 1):
    solve(i)
    print()
