#include <bits/stdc++.h>

#define int long long
#define pb emplace_back
#define mp make_pair
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(time(nullptr));

const int inf = 1e18;
const ll M = 1e9 + 7;
const ld pi = atan2(0, -1);
const ld eps = 1e-6;

string to_bin(int x, int k){
    string s;
    while (x > 0){
        s += '0' + x % 2;
        x /= 2;
    }
    while(s.size() < k){
        s += '0';
    }
    //reverse(all(s));
    return s;
}

void solve(int tc) {
    int n, k;
    cin >> n >> k;
    vector<int> c(1 << k);
    if(n < k){
        cout << string(n, '0');
        return;
    }
    for(int &e: c) cin >> e;
    vector<vector<int>> prev(1 << k, vector<int>(2));
    for(int i = 0; i < (1 << k); ++i){
        int nxt = i >> 1;
        prev[i][0] = nxt;
        prev[i][1] = (1 << (k - 1)) + nxt;
    }
    vector<vector<int>> dp(n - k + 1, vector<int>(1 << k, inf));
    dp[0] = c;
    for(int i = 1; i <= n - k; ++i){
        for(int j = 0; j < (1 << k); ++j){
            dp[i][j] = min(dp[i - 1][prev[j][0]], dp[i - 1][prev[j][1]]) + c[j];
        }
    }
    int i = n - k;
    int j = min_element(all(dp.back())) - dp.back().begin();
    string ans = to_bin(j, k);
    while (i > 0){
        if(dp[i - 1][prev[j][0]] < dp[i - 1][prev[j][1]]){
            ans += '0';
            j = prev[j][0];
        }
        else{
            ans += '1';
            j = prev[j][1];
        }
        i--;
    }
    reverse(all(ans));
    cout << ans;
}

bool multi = false;

signed main() {
    int t = 1;
    if(multi) cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << "\n";
    }
    return 0;
}