#include <bits/stdc++.h>

#define int long long
#define pb emplace_back
#define mp make_pair
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(time(nullptr));

const int inf = 1e18;
const ll M = 1e9 + 7;
const ld pi = atan2(0, -1);
const ld eps = 1e-6;

vector<int> c;

int get_piece_cost(string s){
    int res = 0;
    for(char c: s){
        res = 2 * res + (c - '0');
    }
    return c[res];
}

int get_cost(string s, int n, int k){
    int res = 0;
    for(int i = 0; i + k <= n; ++i){
        res += get_piece_cost(s.substr(i, k));
    }
    return res;
}

string to_bin(int x, int k){
    string s;
    while (x > 0){
        s += '0' + x % 2;
        x /= 2;
    }
    while(s.size() < k){
        s += '0';
    }
    reverse(all(s));
    return s;
}

void solve(int tc) {
    int n, k;
    cin >> n >> k;
    c.resize(1 << k);
    for(int &e: c) cin >> e;
    if(n > 30){
        while(true);
    }
    int ans = 0;
    int cost = get_cost(to_bin(ans, n), n, k);
    for(int i = 0; i < (1 << n); ++i){
        int cs = get_cost(to_bin(i, n), n, k);
        if(cs < cost){
            ans = i;
            cost = cs;
        }
    }
    cout << to_bin(ans, n);
}

bool multi = false;

signed main() {
    int t = 1;
    if(multi) cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << "\n";
    }
    return 0;
}