#include "testlib.h"

using namespace std;

#define all(c) c.begin(), c.end()

bool valid(vector<int> const &targets) {
    for (int i = 0; i < targets.size(); i++) {
        if (targets[i] == i / 2) return false;
    }
    return true;
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), a = opt<int>("a"), b = opt<int>("b");

    vector<int> targets(2 * n);
    for (int i = 0; i < targets.size(); i++) {
        targets[i] = i / 2;
    }
    while (!valid(targets)) {
        shuffle(all(targets));
    }

    println(n);
    for (int i = 0; i < 2 * n; i++) {
        int ai = rnd.next(a, b), bi = rnd.next(a, b);
        if (ai > bi) swap(ai, bi);
        println(targets[i] + 1, ai, bi);
    }

}