using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    int n = 1 + rnd.wnext(max_n, 10);

    printf("%d\n", n);

    const int max_l = has_opt("l") ? opt<int>("l") : MAX_L;
    for (int i = 0; i < n; ++i) {
        int x = rnd.next(1, max_l);
        int y = rnd.next(1, max_l);
        printf("%d %d\n", x, y);
    }

    return 0;
}
