#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <random>
#include <cstring>
#include <numeric>
#include <queue>
#include <cassert>
#include <fstream>
#include <sstream>
#include <bitset>

using namespace std;

#define fori(n)for (long long i = 0; i < (n); i++)
#define re return
#define ll long long
#define vec vector

template<class T> void umin(T& a, T b) { a = min(a, b); }

const ll infin = 1000'000'000'000'000ll;
ll dj(vec<vec<pair<int, ll>>>& v, int s, int e) {
	set<pair<ll, int>> st;
	vec<ll> dist(v.size(), infin);
	st.insert({ 0, s });
	dist[s] = 0;

	while (st.size()) {
		auto it = st.begin();
		int i = (*it).second;
		ll d = (*it).first;

		if (i == e)re d;

		st.erase(st.begin());

		for (auto j : v[i]) {
			if (dist[j.first] > j.second + d) {
				if (dist[j.first] < infin)st.erase(st.find({ dist[j.first], j.first }));
				dist[j.first] = j.second + d;
				st.insert({ j.second + d, j.first });
			}
		}
	}
	
	re -1;
}

int main() {
	ll n, x; cin >> n >> x;
	vec<vec<pair<int, ll>>> v(n * 2);
	ll m; cin >> m;
	fori(m) {
		ll a, b, c; cin >> a >> b >> c;
		--a; --b;
		v[a].push_back({ b, c });
		v[b].push_back({ a, c });
	}

	cin >> m;
	fori(m) {
		ll a, b, c; cin >> a >> b >> c;
		--a; --b;
		v[a + n].push_back({ b + n, c });
		v[b + n].push_back({ a + n, c });
	}

	fori(n) {
		v[i].push_back({ i + n, x });
		v[i + n].push_back({ i, x });
	}

	int s, e; cin >> s >> e;
	--s; --e;

	cout << dj(v, s, e + n);
}