using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    int n = 1 + rnd.wnext(max_n, 10);

    const int max_l = max(n, has_opt("l") ? opt<int>("l") : MAX_L);

    int c = rnd.next(0, n - 1);

    printf("%d %d\n", n, c);

    set<int> a;
    for (int i = 0; i < n; ++i) {
        int e;
        do {
            e = rnd.next(1, max_l);
        } while (a.find(e) != a.end());
        a.insert(e);
    }

    bool was = false;
    for (int e: a) {
        if (was) {
            printf(" ");
        } else {
            was = true;
        }
        printf("%d", e);
    }
    printf("\n");

    return 0;
}
