//#include "../testlib/testlib.h"
#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    vector<vector<int>> g (n, vector<int>());

    for (int i = 0; i < n - 1; i++) {
        int u = inf.readInt();
        int v = inf.readInt();
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }

    vector<vector<int>> sons (n, vector<int>());
    queue<int> q;
    q.push(0);
    vector<int> u2 (n, 0);
    while (!q.empty()) {
        int v = q.front();
        u2[v] = 1;
        q.pop();
        for (int u: g[v]) {
            if (u2[u]) {
                continue;
            }
            q.push(u);
            sons[v].push_back(u);
        }
    }

    int partCnt = ouf.readInt(0, n, "part_cnt");
    int juryCnt = ans.readInt(0, n, "jury_cnt");

    int partVCnt = ouf.readInt(0, n, "part_v_cnt");

    if (partCnt < juryCnt) {
        quitf(_wa, "Jury found better answer - %d, while participant - %d", juryCnt, partCnt);
    }

    vector<int> part_v (partVCnt);
    vector<int> p_chosen (n, 0);
    for (int i = 0; i < partVCnt; i++) {
        part_v[i] = ouf.readInt(1, n, "part_v[i]");
        p_chosen[--part_v[i]] = 1;
    }

    int cnt = 0;
    for (int v: part_v) {
        for (int u: sons[v]) {
            if (!p_chosen[u]) {
                cnt++;
            }
        }
    }

    if (cnt == partCnt) {
        if (partCnt > juryCnt) {
            quitf(_fail, "Participant found answer more: %d, jury: %d", partCnt, juryCnt);
        } else {
            quitf(_ok, "Test passed");
        }
    } else {
        quitf(_wa, "Participant answer does not match chosen vertices");
    }
}