using namespace std;

#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>

using ll = long long;
#define X first
#define Y second

int bs(const vector<int> &a, int v) {
    int l = 0;
    int r = (int) a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[m] <= v) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int main() {
    int n;
    cin >> n;

    vector < pair < pair < int, int >, int >> a;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (x != y) {
            a.emplace_back(make_pair(y, x), i);
        }
        a.emplace_back(make_pair(x, y), i);
    }
    sort(a.begin(), a.end());

    n = (int) a.size();
    vector<int> d(n + 1, INT_MAX);
    vector<int> pos(n+1);
    d[0] = INT_MIN;
    pos[0] = -1;

    vector<int> fr(n);

//    for (auto e: a) {
//        cout << e.X.Y << " ";
//    }
//    cout << "\n";

    int r = 0;
    for (int i = 0; i < n; ++i) {
        int j = bs(d, a[i].X.Y);
//        cout << i << " " << j << " " << d[j - 1] << " " << a[i].X.Y << "\n";
        if (d[j - 1] <= a[i].X.Y && a[i].X.Y <= d[j]) {
            d[j] = a[i].X.Y;
            pos[j] = i;
            fr[i] = pos[j-1];
            r = max(r, j);
        }
    }

    vector<int> ans;
    int ps  = pos[r];
    while (ps != -1) {
        ans.push_back(a[ps].Y);
        ps = fr[ps];
    }

    cout << r << "\n";
    for (int i = (int) ans.size() - 1; i >= 0; --i) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}