using namespace std;

#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>

using ll = long long;
#define X first
#define Y second

int main() {
    int n;
    cin >> n;

    vector < pair < pair < int, int >, int >> a;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (x != y) {
            a.emplace_back(make_pair(y, x), i);
        }
        a.emplace_back(make_pair(x, y), i);
    }
    sort(a.begin(), a.end());

    n = (int) a.size();
    vector<int> d(n);
    vector<int> p(n);

    for (int i = 0; i < n; ++i) {
        d[i] = 1;
        p[i] = -1;
        for (int j = 0; j < i; ++j) {
            if (a[j].X.Y <= a[i].X.Y && d[j] + 1 > d[i]) {
                d[i] = d[j] + 1;
                p[i] = j;
            }
        }
    }

    int ps = 0;
    int r = d[0];
    for (int i = 0; i < n; ++i) {
        if (d[i] > r) {
            r = d[i];
            ps = i;
        }
    }

    vector<int> ans;
    while (ps != -1) {
        ans.push_back(a[ps].Y);
        ps = p[ps];
    }

    cout << r << "\n";
    for (int i = (int) ans.size() - 1; i >= 0; --i) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}