#include "testlib.h"
#include <iostream>
#include <map>
#include <vector>

#define vec vector
#define fori(n) for(int i = 0; i < n; ++i)
#define re return

using namespace std;

struct info {
    int a, b, c;
};

vec<info> gen_rand_tree(int n, int m, int mx_c) {
    vec<info> v;
    map<pair<int, int>, bool> mp;

    fori(m) {
        int a = 0, b = 0, c;

        while (a == b || mp[{a, b}]) {
            a = rnd.next(1, n);
            b = rnd.next(1, n);
            c = rnd.next(1, mx_c);
        }

        mp[{a, b}] = 1;
        mp[{b, a}] = 1;

        v.push_back({ a, b, c });
    }

    re v;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m1 = atoi(argv[2]);
    int m2 = atoi(argv[3]);
    int mx_c = atoi(argv[4]);
    int mx_x = 1000'000;
    if (argc > 5)mx_x = atoi(argv[5]);
    int x = rnd.next(1, mx_x);

    cout << n << " " << x << "\n";
    cout << m1 << "\n";
    vec<info> v = gen_rand_tree(n, m1, mx_c);
    fori(m1) {
        cout << v[i].a << ' ' << v[i].b << ' ' << v[i].c << '\n';
    }
    cout << m2 << "\n";
    v = gen_rand_tree(n, m2, mx_c);
    fori(m2) {
        cout << v[i].a << ' ' << v[i].b << ' ' << v[i].c << '\n';
    }

    cout << rnd.next(1, n) << " ";
    cout << rnd.next(1, n) << "\n";
}
