#pragma GCC optimize("O3")
//    #pragma GCC target("avx2")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pii pair<int, int>
#define pb push_back
#define ll long long
#define S second
#define F first
#define ld long double
#define int ll
#define sqr(x) (x)*(x)
#define all(x) (x).begin(),(x).end()

#ifdef LOCAL
#else
    #define cerr if(0) cerr
#endif

using namespace std;
using namespace __gnu_pbds;


template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937_64 gen(chrono::high_resolution_clock().now().time_since_epoch().count());


const int MOD = 1e9 + 7;
const int N = (1 << 20);
#ifdef LOCAL
const int inf = 1e9 + 7;
const int M = (1 << 20);
#else
const int inf = 4e18 + 7;
const int M = (1 << 20);
#endif // LOCAL
int MX = 0.98 * CLOCKS_PER_SEC;

//vector < int > sz(N, 1);
vector < int > pr(N, 1);
vector < int > a(N, 0);

int get_pr(int v) {
    if(pr[v] == v) return v;
    return (pr[v] = get_pr(pr[v]));
}
void merg(int v, int u) {
    v = get_pr(v);
    u = get_pr(u);
    if(u == v) return;
    a[v] += a[u];
    pr[u] = v;
}
main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#else
//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);
#endif LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    s--;

    vector < pair < int, pii > > e(m);

    for(int i = 0; i < n; i++) {
        cin >> a[i];
        pr[i] = i;
    }
    for(int i = 0; i < m; i++){
        cin >> e[i].S.F >> e[i].S.S >> e[i].F;
        e[i].S.F--;
        e[i].S.S--;
    }
    sort(all(e));
    for(auto to : e) {
        int c = a[get_pr(s)];
        if(to.F > c) break;
        merg(to.S.F, to.S.S);
    }
    cout << a[get_pr(s)];
    return 0;
}