using namespace std;

#include <iostream>
#include <vector>
#include <queue>
#include <unordered_set>

using ll = long long;

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    vector <ll> a(n);
    for (int i = 0; i < n; ++i) { cin >> a[i]; }

    vector < vector < pair < int, ll>>> edges(n);
    for (int j = 0; j < m; ++j) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        edges[u].emplace_back(v, w);
        edges[v].emplace_back(u, w);
    }

    ll f = 0;
    unordered_set<int> visited;
    queue<int> visit_next;
    visit_next.push(--s);
    while (!visit_next.empty()) {
        int c = visit_next.front();
        visit_next.pop();
        if (visited.find(c) != visited.end()) {
            continue;
        }
        visited.insert(c);

        f += a[c];
        for (int u: visited) {
            for (auto [v, w]: edges[u]) {
                if (w <= f && visited.find(v) == visited.end()) {
                    visit_next.push(v);
                }
            }
        }
    }
    cout << f << "\n";
}