#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m"), w = opt<int>("w");
    vector<vector<int>> field(n, vector<int>(m));

    int x = 0, y = 0;
    while (x < n - 1 || y < m - 1) {
        field[x][y] = 1;
        if (rnd.next(2) && x < n - 1 || y == m - 1) x++;
        else y++;
    }
    field[x][y] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (rnd.wnext(2, w)) field[i][j] = 1;
        }
    }

    vector<int> rmod(n), cmod(m);
    for (int i = 0; i < n; i++) {
        rmod[i] = rnd.next(2);
    }
    for (int j = 0; j < m; j++) {
        cmod[j] = rnd.next(2);
    }

    println(n, m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << (field[i][j] ^ rmod[i] ^ cmod[j]);
        }
        cout << '\n';
    }

}