#include "testlib.h"
#include <iostream>

using namespace std;

int const Q_MAX = 42;

int main(int argc, char *argv[]) {
    registerInteraction(argc, argv);

    int n = inf.readInt();
    int c = inf.readInt();
    vector<int> a = inf.readInts(n);

    cout << n << endl << flush;

    vector<int> qs;
    int queries = 0;
    while (true) {
        string action = ouf.readToken("!|\?");
        if (action == "!") {
            int res = ouf.readInt(0, n - 1, "c");
            tout << "answer " << res << "\n";
            tout << "queries " << queries << "\n";
            break;
        }

        if (++queries > Q_MAX) {
            cout << "-1\n" << flush;
            quitf(_wa, "too much queries");
        }
        int x = ouf.readInt(1, n);
        qs.push_back(x);
        cout << a[(x - 1 + c) % n] << "\n" << flush;
    }


    // just message
    quitf(_ok, "%d queries processed", n);
}
